# CustomExternalForce Class Reference

This class implements an "external" force on particles. More...

`#include <CustomExternalForce.h>`

Inheritance diagram for CustomExternalForce:

List of all members.

## Classes

class | GlobalParameterInfo
| This is an internal class used to record information about a global parameter.
class | ParticleInfo
| This is an internal class used to record information about a particle.
class | ParticleParameterInfo
| This is an internal class used to record information about a per-particle parameter.

## Public Member Functions

| CustomExternalForce (const std::string &energy)
| Create a CustomExternalForce.
int | getNumParticles () const
| Get the number of particles for which force field parameters have been defined.
int | getNumPerParticleParameters () const
| Get the number of per-particle parameters that the force depends on.
int | getNumGlobalParameters () const
| Get the number of global parameters that the force depends on.
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the potential energy of each particle.
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the potential energy of each particle.
int | addPerParticleParameter (const std::string &name)
| Add a new per-particle parameter that the force may depend on.
const std::string & | getPerParticleParameterName (int index) const
| Get the name of a per-particle parameter.
void | setPerParticleParameterName (int index, const std::string &name)
| Set the name of a per-particle parameter.
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the force may depend on.
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter.
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter.
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter.
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter.
int | addParticle (int particle, const std::vector< double > &parameters)
| Add a particle term to the force field.
void | getParticleParameters (int index, int &particle, std::vector< double > &parameters) const
| Get the force field parameters for a force field term.
void | setParticleParameters (int index, int particle, const std::vector< double > &parameters)
| Set the force field parameters for a force field term.
void | updateParametersInContext (Context &context)
| Update the per-particle parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements an "external" force on particles.

The force may be applied to any subset of the particles in the System. The force on each particle is specified by an arbitrary algebraic expression, which may depend on the current position of the particle as well as on arbitrary global and per-particle parameters.

To use this class, create a CustomExternalForce object, passing an algebraic expression to the constructor that defines the potential energy of each affected particle. The expression may depend on the particle's x, y, and z coordinates, as well as on any parameters you choose. Then call addPerParticleParameter() to define per-particle parameters, and addGlobalParameter() to define global parameters. The values of per-particle parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter(). Finally, call addParticle() once for each particle that should be affected by the force. After a particle has been added, you can modify its parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomExternalForce that attracts each particle to a target position (x0, y0, z0) via a harmonic potential:

`CustomExternalForce* force = new CustomExternalForce("k*((x-x0)^2+(y-y0)^2+(z-z0)^2)");`

This force depends on four parameters: the spring constant k and equilibrium coordinates x0, y0, and z0. The following code defines these parameters:

``

     force->addGlobalParameter("k", 100.0);
     force->addPerParticleParameter("x0");
     force->addPerParticleParameter("y0");
     force->addPerParticleParameter("z0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, step, delta. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise.

## Constructor & Destructor Documentation

CustomExternalForce | ( | const std::string & | energy | ) | `[explicit]`

Create a CustomExternalForce.

Parameters:

  | energy | an algebraic expression giving the potential energy of each particle as a function of its x, y, and z coordinates

## Member Function Documentation

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue |
| ) |  |  |

Add a new global parameter that the force may depend on.

Parameters:

  | name | the name of the parameter
  | defaultValue | the default value of the parameter

Returns:
  the index of the parameter that was added

int addParticle | ( | int | particle,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Add a particle term to the force field.

Parameters:

  | particle | the index of the particle this term is applied to
  | parameters | the list of parameters for the new force term

Returns:
  the index of the particle term that was added

int addPerParticleParameter | ( | const std::string & | name | ) |

Add a new per-particle parameter that the force may depend on.

Parameters:

  | name | the name of the parameter

Returns:
  the index of the parameter that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the potential energy of each particle.

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the default value

Returns:
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

int getNumGlobalParameters | ( |  | ) | const`[inline]`

Get the number of global parameters that the force depends on.

int getNumParticles | ( |  | ) | const`[inline]`

Get the number of particles for which force field parameters have been defined.

int getNumPerParticleParameters | ( |  | ) | const`[inline]`

Get the number of per-particle parameters that the force depends on.

void getParticleParameters | ( | int | index,
|  | int & | particle,
|  | std::vector< double > & | parameters |
| ) |  |  | const

Get the force field parameters for a force field term.

Parameters:

  | index | the index of the particle term for which to get parameters
  | particle | the index of the particle this term is applied to
  | parameters | the list of parameters for the force field term

const std::string& getPerParticleParameterName | ( | int | index | ) | const

Get the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to get the name

Returns:
  the parameter name

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the potential energy of each particle.

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue |
| ) |  |  |

Set the default value of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the default value
  | name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a global parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void setParticleParameters | ( | int | index,
|  | int | particle,
|  | const std::vector< double > & | parameters |
| ) |  |  |

Set the force field parameters for a force field term.

Parameters:

  | index | the index of the particle term for which to set parameters
  | particle | the index of the particle this term is applied to
  | parameters | the list of parameters for the force field term

void setPerParticleParameterName | ( | int | index,
|  | const std::string & | name |
| ) |  |  |

Set the name of a per-particle parameter.

Parameters:

  | index | the index of the parameter for which to set the name
  | name | the name of the parameter

void updateParametersInContext | ( | Context & | context | ) |

Update the per-particle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-particle parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. Also, this method cannot be used to add new particles, only to change the parameters of existing ones.

The documentation for this class was generated from the following file:

- CustomExternalForce.h